package com.dbxml.db.common.fulltext;

/*
 * dbXML - Native XML Database
 * Copyright (C) 1999-2004  The dbXML Group, L.L.C.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * $Id: FullTextResultSet.java,v 1.3 2004/02/12 00:17:56 bradford Exp $
 */

import com.dbxml.db.common.query.ResultSetBase;
import com.dbxml.db.core.Collection;
import com.dbxml.db.core.DBException;
import com.dbxml.db.core.data.Key;
import com.dbxml.db.core.query.ProcessingException;
import com.dbxml.db.core.query.Query;
import com.dbxml.db.core.query.QueryException;
import com.dbxml.db.core.transaction.Transaction;
import com.dbxml.xml.dtsm.Constants;
import com.dbxml.xml.dtsm.DocumentTable;

/**
 * FullTextResultSet
 */

public final class FullTextResultSet extends ResultSetBase {
   public FullTextResultSet(Transaction tx, Collection context, Query query, Key[] keySet) {
      super(tx, context, query, keySet);
   }

   public boolean next() throws QueryException {
      checkOpened();

      return nextKey() != null;
   }

   public int getResultType() throws QueryException {
      checkOpened();
      return Constants.OBJ_BEGIN_DOCUMENT;
   }

   public DocumentTable getResult() throws QueryException {
      checkOpened();
      try {
         return context.getDocument(tx, currentKey);
      }
      catch ( DBException e ) {
         throw new ProcessingException("Error retrieving Document '"+currentKey.toString()+"'", e);
      }
   }
}
